unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    UpDown1: TUpDown;
    UpDown2: TUpDown;
    Label1: TLabel;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure UpDown1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure UpDown2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses Xbitmap_unit;

var map : TXbitmap;

procedure drawPatterns;
//draw in map, using Xbitmap features
var i : word;
begin
 with map do with canvas do
  begin
   brush.Style := bsSolid;
   brush.color := $ffffff;
   fillrect(rect(0,0,width,height));
   i := 0;
   pen.color := $fff0f0;
   while i < width do
    begin
     moveto(i,0);
     lineto(i,height);
     inc(i,20);
    end;
   i := 0;
   while i < height do
    begin
     moveto(0,i);
     lineto(width,i);
     inc(i,20);
    end;
  end;//with

//--- XBitmap part
  with map do
   begin
    Xpencolor := $000000;
    Xpenwidth := form1.UpDown1.position;
    XlineStyle := form1.UpDown2.position;
    Xline(15,30,545,30);
   end;
//-----------------

 form1.PaintBox1.Canvas.Draw(0,0,map);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 map := TXbitmap.create;
 with map do
  begin
   width := paintbox1.Width;
   height := paintbox1.Height;
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 map.Free;
end;

procedure TForm1.FormPaint(Sender: TObject);
//edges around paintbox
var x1,y1,x2,y2 : word;
    i : byte;
begin
 with paintbox1 do
  begin
   x1 := left-2;
   x2 := left + width + 1;
   y1 := top-2;
   y2 := top + height+1;
  end;
 with canvas do
  begin
   pen.Width := 1;
   for i := 0 to 1 do
    begin
     pen.color := $000000;
     moveto(x2-i,y1+i);
     lineto(x1+i,y1+i);
     lineto(x1+i,y2-i);
     pen.Color := $808080;
     lineto(x2-i,y2-i);
     lineto(x2-i,y1+i);
    end;
  end;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
 drawpatterns;
end;

procedure TForm1.UpDown1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 drawpatterns;
end;

procedure TForm1.UpDown2MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 drawpatterns;
end;

end.
